/* ContractMatcher.c generated by valac 0.38.10, the Vala compiler
 * generated from ContractMatcher.vala, do not modify */

/*
 * Copyright (C) 2011-2017 elementary Developers
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define CONTRACTOR_TYPE_CONTRACT (contractor_contract_get_type ())
#define CONTRACTOR_CONTRACT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONTRACTOR_TYPE_CONTRACT, ContractorContract))
#define CONTRACTOR_CONTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONTRACTOR_TYPE_CONTRACT, ContractorContractClass))
#define CONTRACTOR_IS_CONTRACT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONTRACTOR_TYPE_CONTRACT))
#define CONTRACTOR_IS_CONTRACT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONTRACTOR_TYPE_CONTRACT))
#define CONTRACTOR_CONTRACT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONTRACTOR_TYPE_CONTRACT, ContractorContractClass))

typedef struct _ContractorContract ContractorContract;
typedef struct _ContractorContractClass ContractorContractClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	CONTRACTOR_CONTRACTOR_ERROR_NO_MIMETYPES_GIVEN
} ContractorContractorError;
#define CONTRACTOR_CONTRACTOR_ERROR contractor_contractor_error_quark ()


GType contractor_contract_get_type (void) G_GNUC_CONST;
GQuark contractor_contractor_error_quark (void);
GeeCollection* contractor_contract_matcher_get_contracts_for_types (gchar** mime_types, int mime_types_length1, GeeCollection* contracts_to_filter, GError** error);
gchar** contractor_string_clean_array (gchar** str_array, int str_array_length1, int* result_length1);
gboolean contractor_contract_supports_mime_type (ContractorContract* self, const gchar* mime_type);
GeeCollection* contractor_contract_matcher_get_contracts_for_file_size (gint64 file_size, GeeCollection* contracts_to_filter, GError** error);
gboolean contractor_contract_supports_file_size (ContractorContract* self, gint64 file_size);
GeeCollection* contractor_contract_matcher_get_contracts_for_types_and_file_size (gchar** mime_types, int mime_types_length1, gint64 file_size, GeeCollection* contracts_to_filter, GError** error);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


/**
     * get contracts which support the passed MIME types
     *
     * @param mime_types the MIME types which have to be supported by the returned contracts
     * @param contracts_to_filter a list of contracts to filter
     *
     * @return a Collection of Contract objects which support the file size
     */
GeeCollection* contractor_contract_matcher_get_contracts_for_types (gchar** mime_types, int mime_types_length1, GeeCollection* contracts_to_filter, GError** error) {
	GeeCollection* result = NULL;
	GeeLinkedList* valid_contracts = NULL;
	GeeLinkedList* _tmp0_;
	gchar** valid_mime_types = NULL;
	gchar** _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_;
	gchar** _tmp3_;
	gint valid_mime_types_length1;
	gint _valid_mime_types_size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (contracts_to_filter != NULL, NULL);
	_tmp0_ = gee_linked_list_new (CONTRACTOR_TYPE_CONTRACT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	valid_contracts = _tmp0_;
	_tmp1_ = mime_types;
	_tmp1__length1 = mime_types_length1;
	_tmp3_ = contractor_string_clean_array (_tmp1_, _tmp1__length1, &_tmp2_);
	valid_mime_types = _tmp3_;
	valid_mime_types_length1 = _tmp2_;
	_valid_mime_types_size_ = valid_mime_types_length1;
	_tmp4_ = valid_mime_types;
	_tmp4__length1 = valid_mime_types_length1;
	if (_tmp4__length1 == 0) {
		GError* _tmp5_;
		_tmp5_ = g_error_new_literal (CONTRACTOR_CONTRACTOR_ERROR, CONTRACTOR_CONTRACTOR_ERROR_NO_MIMETYPES_GIVEN, "No mimetypes were provided.");
		_inner_error_ = _tmp5_;
		if (_inner_error_->domain == CONTRACTOR_CONTRACTOR_ERROR) {
			g_propagate_error (error, _inner_error_);
			valid_mime_types = (_vala_array_free (valid_mime_types, valid_mime_types_length1, (GDestroyNotify) g_free), NULL);
			_g_object_unref0 (valid_contracts);
			return NULL;
		} else {
			valid_mime_types = (_vala_array_free (valid_mime_types, valid_mime_types_length1, (GDestroyNotify) g_free), NULL);
			_g_object_unref0 (valid_contracts);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	{
		GeeIterator* _contract_it = NULL;
		GeeCollection* _tmp6_;
		GeeIterator* _tmp7_;
		_tmp6_ = contracts_to_filter;
		_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
		_contract_it = _tmp7_;
		while (TRUE) {
			GeeIterator* _tmp8_;
			gboolean _tmp9_;
			ContractorContract* contract = NULL;
			GeeIterator* _tmp10_;
			gpointer _tmp11_;
			gboolean all_types_supported = FALSE;
			gchar** _tmp12_;
			gint _tmp12__length1;
			gboolean _tmp17_;
			_tmp8_ = _contract_it;
			_tmp9_ = gee_iterator_next (_tmp8_);
			if (!_tmp9_) {
				break;
			}
			_tmp10_ = _contract_it;
			_tmp11_ = gee_iterator_get (_tmp10_);
			contract = (ContractorContract*) _tmp11_;
			all_types_supported = TRUE;
			_tmp12_ = valid_mime_types;
			_tmp12__length1 = valid_mime_types_length1;
			{
				gchar** mime_type_collection = NULL;
				gint mime_type_collection_length1 = 0;
				gint _mime_type_collection_size_ = 0;
				gint mime_type_it = 0;
				mime_type_collection = _tmp12_;
				mime_type_collection_length1 = _tmp12__length1;
				for (mime_type_it = 0; mime_type_it < _tmp12__length1; mime_type_it = mime_type_it + 1) {
					gchar* _tmp13_;
					gchar* mime_type = NULL;
					_tmp13_ = g_strdup (mime_type_collection[mime_type_it]);
					mime_type = _tmp13_;
					{
						ContractorContract* _tmp14_;
						const gchar* _tmp15_;
						gboolean _tmp16_;
						_tmp14_ = contract;
						_tmp15_ = mime_type;
						_tmp16_ = contractor_contract_supports_mime_type (_tmp14_, _tmp15_);
						if (!_tmp16_) {
							all_types_supported = FALSE;
							_g_free0 (mime_type);
							break;
						}
						_g_free0 (mime_type);
					}
				}
			}
			_tmp17_ = all_types_supported;
			if (_tmp17_) {
				GeeLinkedList* _tmp18_;
				ContractorContract* _tmp19_;
				_tmp18_ = valid_contracts;
				_tmp19_ = contract;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp18_, _tmp19_);
			}
			_g_object_unref0 (contract);
		}
		_g_object_unref0 (_contract_it);
	}
	result = (GeeCollection*) valid_contracts;
	valid_mime_types = (_vala_array_free (valid_mime_types, valid_mime_types_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


/**
     * get contracts which support the passed file size
     *
     * @param file_size the file size which has to be supported by the returned contracts
     * @param contracts_to_filter a list of contracts to filter
     *
     * @return a Collection of Contract objects which support the file size
     */
GeeCollection* contractor_contract_matcher_get_contracts_for_file_size (gint64 file_size, GeeCollection* contracts_to_filter, GError** error) {
	GeeCollection* result = NULL;
	GeeLinkedList* valid_contracts = NULL;
	GeeLinkedList* _tmp0_;
	g_return_val_if_fail (contracts_to_filter != NULL, NULL);
	_tmp0_ = gee_linked_list_new (CONTRACTOR_TYPE_CONTRACT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	valid_contracts = _tmp0_;
	{
		GeeIterator* _contract_it = NULL;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		_tmp1_ = contracts_to_filter;
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
		_contract_it = _tmp2_;
		while (TRUE) {
			GeeIterator* _tmp3_;
			gboolean _tmp4_;
			ContractorContract* contract = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			gboolean file_size_supported = FALSE;
			ContractorContract* _tmp7_;
			gint64 _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
			_tmp3_ = _contract_it;
			_tmp4_ = gee_iterator_next (_tmp3_);
			if (!_tmp4_) {
				break;
			}
			_tmp5_ = _contract_it;
			_tmp6_ = gee_iterator_get (_tmp5_);
			contract = (ContractorContract*) _tmp6_;
			file_size_supported = TRUE;
			_tmp7_ = contract;
			_tmp8_ = file_size;
			_tmp9_ = contractor_contract_supports_file_size (_tmp7_, _tmp8_);
			if (!_tmp9_) {
				file_size_supported = FALSE;
			}
			_tmp10_ = file_size_supported;
			if (_tmp10_) {
				GeeLinkedList* _tmp11_;
				ContractorContract* _tmp12_;
				_tmp11_ = valid_contracts;
				_tmp12_ = contract;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, _tmp12_);
			}
			_g_object_unref0 (contract);
		}
		_g_object_unref0 (_contract_it);
	}
	result = (GeeCollection*) valid_contracts;
	return result;
}


/**
     * get contracts which support the passed MIME types and file size
     *
     * @param mime_types the MIME types which have to be supported by the returned contracts
     * @param file_size the file size which has to be supported by the returned contracts
     * @param contracts_to_filter a list of contracts to filter
     *
     * @return a Collection of Contract objects which support the MIME types and the file size
     */
GeeCollection* contractor_contract_matcher_get_contracts_for_types_and_file_size (gchar** mime_types, int mime_types_length1, gint64 file_size, GeeCollection* contracts_to_filter, GError** error) {
	GeeCollection* result = NULL;
	GeeCollection* contracts_for_types = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* valid_contracts = NULL;
	gint64 _tmp3_;
	GeeCollection* _tmp4_;
	GeeCollection* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (contracts_to_filter != NULL, NULL);
	_tmp0_ = mime_types;
	_tmp0__length1 = mime_types_length1;
	_tmp1_ = contracts_to_filter;
	_tmp2_ = contractor_contract_matcher_get_contracts_for_types (_tmp0_, _tmp0__length1, _tmp1_, &_inner_error_);
	contracts_for_types = _tmp2_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == CONTRACTOR_CONTRACTOR_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp3_ = file_size;
	_tmp4_ = contracts_for_types;
	_tmp5_ = contractor_contract_matcher_get_contracts_for_file_size (_tmp3_, _tmp4_, &_inner_error_);
	valid_contracts = _tmp5_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == CONTRACTOR_CONTRACTOR_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (contracts_for_types);
			return NULL;
		} else {
			_g_object_unref0 (contracts_for_types);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	result = valid_contracts;
	_g_object_unref0 (contracts_for_types);
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



